; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    txt2arr PROTO :DWORD,:DWORD

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    LOCAL hArray    :DWORD
    LOCAL hCL       :DWORD
    LOCAL acnt      :DWORD
    LOCAL hMem      :DWORD
    LOCAL flen      :DWORD
    LOCAL fnam      :DWORD

    push esi
    push edi

  ; ---------------------------

    sas hCL, "  one two three 'four four four' five 'six six six' seven eight nine ten  "

    mov acnt, rv(txt2arr,hCL,ADDR hArray)

    print "Correct result test",13,10,13,10

    mov esi, hArray
    mov edi, acnt
  @@:
    print [esi],13,10
    add esi, 4
    sub edi, 1
    jnz @B

    free hArray

  ; ---------------------------

    sas fnam,"\masm32\include\windows.inc"
    mov hMem, InputFile(fnam)
    mov flen, ecx

    print chr$(13,10,13,10)
    print "Benchmark on "
    print fnam,13,10

    invoke GetTickCount
    push eax

    mov acnt, rv(txt2arr,hMem,ADDR hArray)

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)
    print " MS duration",13,10,13,10

  ; ---------------------------

    pop edi
    pop esi

    free hMem
    free hArray

    ret

main endp

; 

align 4

txt2arr proc pText:DWORD,pArray:DWORD

    .data
    align 4
    @_chtbl_@ \
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
    .code

    push ebx
    push esi
    push edi

    xor ebx, ebx                    ; zero the array counter

    invoke StrLen,pText             ; get the buffer length
    add eax, eax                    ; set pointer array size
    mov edx, alloc(eax)             ; allocate pointer array

  ; ======================
    mov esi, pText                  ; text address in ESI
    sub esi, 1
    mov edi, edx                    ; array address in EDI
  ; ======================

  badchar:
    add esi, 1
    movzx eax, BYTE PTR [esi]       ; zero extend byte
    test eax, eax                   ; test for zero terminator
    jz endsrc                       ; exit on terminator
    cmp BYTE PTR [@_chtbl_@+eax], 0 ; test if bad character in table
    je badchar                      ; loop back for next if it is

  ; ========
    mov [edi], esi                  ; write current location to pointer array
    add edi, 4                      ; set next array write location
    add ebx, 1                      ; increment the array counter
  ; ========

    cmp BYTE PTR [esi], 39          ; is it a single quote ?
    je squote
    cmp BYTE PTR [esi], 34          ; is it a double quote ?
    je dquote

  goodchar:
    add esi, 1
    movzx eax, BYTE PTR [esi]       ; zero extend byte
    test eax, eax                   ; test for zero terminator
    jz endsrc                       ; exit on terminator
    cmp BYTE PTR [@_chtbl_@+eax], 0 ; test if bad character in table
    jne goodchar                    ; loop back for next if its not

  ; ========
    mov BYTE PTR [esi], 0           ; overwrite trailing bad char with zero
    jmp badchar
  ; ========

  squote:                           ; single quote
    add esi, 1
    movzx eax, BYTE PTR [esi]
    test eax, eax
    jz endsrc
    sub eax, 39
    jnz squote

    add esi, 1
    mov BYTE PTR [esi], 0
    jmp badchar

  dquote:                           ; double quote
    add esi, 1
    movzx eax, BYTE PTR [esi]
    test eax, eax
    jz endsrc
    sub eax, 34
    jnz dquote

    add esi, 1
    mov BYTE PTR [esi], 0
    jmp badchar

  ; ======================

  endsrc:

; -------------------------------------------------------------------------

  ; -------------------------
  ; multiply array count by 4
  ; -------------------------
    mov eax, ebx                    ; EBX is the array count
    add eax, eax
    add eax, eax

  ; ----------------------
  ; truncate unused memory
  ; ----------------------
    invoke GlobalReAlloc,edx,eax,0  ; EDX is the allocate memory handle being reallocated

  ; -----------------------------------
  ; copy the local array handle back
  ; to the address of the passed handle
  ; -----------------------------------
    mov esi, pArray                 ; load passed handle address into EDX
    mov DWORD PTR [esi], eax        ; store local array handle at address of passed handle

    mov eax, ebx                    ; return array count in EAX

    pop edi
    pop esi
    pop ebx

    ret

txt2arr endp

; 

end start
